Subject: Re: MPLS PWs over IP: Text for draft-ietf-pwe3-control-protocol-04.txt

From: Rahul Aggarwal <[email-masked]>
Date: Mon, 1 Dec 2003 12:31:05 -0800 (PST)

Hi Luca,

How about:

1. >From the current draft-ietf-pwe3-control-protocol-:

   In the protocol specified herein, the pseudowire demultiplexor field
   is an MPLS label.  Thus the packets which are transmitted from one
   end of the pseudowire to the other are MPLS packets.  Unless the
   pseudowire endpoints are immediately adjacent, these MPLS packets
   must be transmitted through a PSN tunnel.  Any sort of PSN tunnel can
   be used, as long as it is possible to transmit MPLS packets through
   it.  The PSN tunnel can itself be an LSP, but it could equally well
   be an IP tunnel, a GRE tunnel, an IPsec tunnel, or any other sort of
   tunnel which can carry MPLS packets. Procedures for setting up and
   maintaining the PSN tunnels are outside the scope of this document.

Can we replace the last sentence in the above with the following:

   Procedures for setting up and maintaining the PSN tunnels with GRE
   or IP are specified in [MPLS-OVER-IP-GRE].

This will clarify that the intention is to use the existing MPLS WG
design for PWs over IP/GRE.

2. draft-raggarwa-pwe3-pw-over-ip-00.txt will be respun to describe
procedures for MPLS PWs over IPsec, only.

Thanks,
rahul

On Wed, 26 Nov 2003, Luca Martini wrote:

> Rahul,
>
> This is a significant change , which is past the last call of the
> document. In addition to that, this design competes with other work
> already submitted to MPLS WG. The pwe3 control draft already states :
> " The PSN tunnel can itself be an LSP, but it could equally well
>    be an IP tunnel, a GRE tunnel, an IPsec tunnel, or any other sort of
>    tunnel which can carry MPLS packets."
>
> it is not in the scope of this document, or WG charter, to specify how
> to carry MPLS in GRE,Ipsec etc.
> I believe that we should take this work   to the MPLS wg as standrads
> track draft.
>
> Tks.
> Luca
>
>
>
> Rahul Aggarwal wrote:
>
> >Hi Luca,
> >
> >Following up on the discussion on MPLS PWs over IP at the last IETF, here
> >is suggested text for draft-ietf-pwe3-control-protocol-04.txt. It applies
> >to section 3. Please let me know what you think.
> >
> >Thanks,
> >rahul
> >
> >-------------------------------------------------------------------------------
> >3. The Pseudowire Label
> >
> >.....
> >
> >So when PE1 sends a layer 2 PDU to PE2, it first pushes a PW label on
> >   its label stack, thereby creating an MPLS packet.  It then (if PE1 is
> >   not adjacent to PE2) encapsulates that MPLS packet in a PSN tunnel
> >   header.  (If the PSN tunnel is an LSP, this is just a matter of
> >   pushing on a second label.)  The PW label is not visible again until
> >   the MPLS packet reaches PE2. PE2's disposition of the packet is based
> >   on the PW label.
> >
> ><Delete : (If the PSN tunnel is.....second label) >
> >
> >Note that the PW label must always be at the bottom of the packet's
> >label stack and labels MUST be allocated from the per-platform label
> >space
> >
> ><Inserted Text Begin>
> >
> >If the PSN tunnel is an MPLS LSP, then putting on a PSN tunnel encapsulation
> >is a matter of pushing an additional MPLS label on the packet. This
> >upper MPLS label is the MPLS LSP label that causes the packet to be
> >delivered to the egress of the PW i.e PE2.
> >
> >In order to enable MPLS PWs to be deployed when there are non-MPLS routers
> >along the path between ingress and egress PE routers, it may be desirable
> >to use an IP or GRE PSN tunnel. In this case MPLS-in-IP or MPLS-in-GRE
> >[MPLS-OVER-IP-GRE] encapsulation is used to turn the MPLS PW packet into
> >an IP packet. The IP source address will be the address of the PW ingress
> >and the IP destination address will be the address of the PW egress. The
> >net effect is that a MPLS PW packet gets sent through a dynamically
> >created IP or GRE PSN tunnel. The egress PE decapsulates the MPLS-in-IP
> >or MPLS-in-GRE packets as in [MPLS-OVER-IP-GRE] and processes the
> >resulting MPLS PW packets.
> >
> >It may also be desirable to use an IPsec PSN tunnel [RFC2402, RFC2406] to
> >enable MPLS PW packets to be carried securely over non-MPLS networks.
> >One possible mechanism to achieve this is that the ingress PE creates an
> >MPLS-in-IP or MPLS-in-GRE encapsulated packet, as above. If required the
> >ingress PE then sets up a IPsec Security Association to the egress PE.
> >Appropriate IPsec procedures are then applied generating a packet with an
> >IP header followed by an IPsec header followed by MPLS-in-IP or MPLS-in-GRE
> >encapsulated MPLS PW packet. The egress PE applies the necessary IPsec
> >procedures to the arriving IPsec packets and recovers the contained
> >MPLS-in-IP or MPLS-in-GRE packets, which are then appropriately processed.
> >
> ><Inserted Text End>
> >
> >
> >[MPLS-OVER-IP-GRE] "Encapsulating MPLS in IP or GRE", T. Worster,
> >                   Rekhter Y., Rosen E., draft-ietf-mpls-in-ip-or-gre-03.txt
> >[RFC2402] Kent, S. and R. Atkinson, "IP Authentication Header", RFC
> >          2402, November 1998.
> >
> >[RFC2406] Kent,S. and R. Atkinson, "IP Encapsulating Security Payload
> >          (ESP)", RFC 2406, November 1998.
> >
> >
> >
> >
> >
> >
> >
> >
> >
> >
> >
> >
> >
>
>

---

From: Eric Rosen <[email-masked]>
Date: Mon, 01 Dec 2003 16:02:15 -0500

draft> Any sort  of PSN tunnel can  be used, as  long as it is  possible to
draft> transmit MPLS packets  through it.  The PSN tunnel  can itself be an
draft> LSP, but  it could equally  well be an  IP tunnel, a GRE  tunnel, an
draft> IPsec  tunnel, or  any other  sort of  tunnel which  can  carry MPLS
draft> packets. Procedures  for setting up and maintaining  the PSN tunnels
draft> are outside the scope of this document. 

Rahul> Can we replace the last sentence in the above with the following:

Rahul>    Procedures for setting up and maintaining the PSN tunnels with GRE
Rahul>    or IP are specified in [MPLS-OVER-IP-GRE].

Since this change is not needed for technical correctness, I would prefer to
leave the draft as is.

Rahul> This will clarify that the intention is to use the existing MPLS WG
Rahul> design for PWs over IP/GRE.

How to carry  MPLS through a non-MPLS  network is out of scope;  I don't see
what intention needs to be clarified.

---

From: Stewart Bryant <[email-masked]>
Date: Tue, 02 Dec 2003 13:15:29 +0000

>    or IP are specified in [MPLS-OVER-IP-GRE].

The new text is prescriptive about MPLS-OVER-IP-GRE being THE method.
Do we have WG concensus for that?

Stewart

---

From: Dan Tappan <[email-masked]>
Date: Tue, 02 Dec 2003 08:36:27 -0500

>Do we have WG concensus for that?

All other issues aside: if [MPLS-OVER-IP-GRE] means 
http://www.ietf.org/internet-drafts/draft-ietf-mpls-in-ip-or-gre-03.txt, 
that draft does not contain any procedures for setting up or maintaining 
PSN tunnels with GRE or IP. It describes encapsulation procedures.

---

From: "Andrew G. Malis" <[email-masked]>
Date: Tue, 02 Dec 2003 09:14:32 -0500

Stewart and Dan,

>>Do we have WG concensus for that?

Yes, that was the whole point of the discussion in Minneapolis, and the 
continuation on the list.  draft-ietf-mpls-in-ip-or-gre-03.txt is the MPLS 
WG draft for transporting MPLS packets through non-MPLS IP 
networks.  There's no need for the PWE3 WG to either redefine what's in 
this draft, or even worse, define something else entirely.

>PSN tunnels with GRE or IP. It describes encapsulation procedures.

Well, encapsulation is all that's really needed to "set up or maintain PSN 
tunnels with GRE or IP".  Plus the draft discusses the relationship between 
the tunnel header and the outer MPLS label.  So it's really all that's 
needed for PWE3 purposes.

Cheers,
Andy

---

From: "W. Mark Townsley" <[email-masked]>
Date: Tue, 02 Dec 2003 16:18:27 +0100

Andrew G. Malis wrote:
> continuation on the list.  draft-ietf-mpls-in-ip-or-gre-03.txt is the 
> MPLS WG draft for transporting MPLS packets through non-MPLS IP 

Further, there is no reason for the PWE3 WG to make special reference to this or 
any other specific tunneling draft. Currently, the text in this paragraph reads 
that "Any sort of PSN tunnel can be used, as long as it is possible to transmit 
MPLS packets through it." and lists MPLS, GRE, IP, IPsec, all simply as 
examples. The paragraph goes to to say that any tunnel setup mechanisms 
(including an MPLS LSP or any other tunnel type, listed as an example or not) 
are simply out of scope in this WG. This is perfectly inline with the charter. 
Calling out a reference to a given specific document for GRE and IP seems 
arbitrary, changes the scope of this document, and if done as suggested leaves 
other tunnel methods dangling.

- Mark

>> that draft does not contain any procedures for setting up or 
>> maintaining PSN tunnels with GRE or IP. It describes encapsulation 
>> procedures.
> 
> 
> Well, encapsulation is all that's really needed to "set up or maintain 
> PSN tunnels with GRE or IP".  
 > Plus the draft discusses the relationship
> between the tunnel header and the outer MPLS label.  So it's really all 
> that's needed for PWE3 purposes.
> 
> Cheers,
> Andy
> 
>

---

From: Stewart Bryant <[email-masked]>
Date: Tue, 02 Dec 2003 16:32:31 +0000

> this draft, or even worse, define something else entirely.

... and Luca's original text said that the method of encapsulation was out
or PWE3 scope (and by implication in MPLS scope), so it sounds as if
his text should stand unchanged.

> PSN tunnels with GRE or IP".  Plus the draft discusses the relationship 

... but do we really need to add the reference? Surely it is adequate to
leave the text, or PERHAPS to say something like "such methods as are
aproved by the MPLS WG"?

Stewart

---

From: "W. Mark Townsley" <[email-masked]>
Date: Tue, 02 Dec 2003 18:04:52 +0100

Stewart Bryant wrote:
>> Yes, that was the whole point of the discussion in Minneapolis, and 
>> the continuation on the list.  draft-ietf-mpls-in-ip-or-gre-03.txt is 
>> the MPLS WG draft for transporting MPLS packets through non-MPLS IP 
>> networks.  There's no need for the PWE3 WG to either redefine what's 
>> in this draft, or even worse, define something else entirely.
>>
> 
>> PSN tunnels with GRE or IP".  Plus the draft discusses the 
>> relationship between the tunnel header and the outer MPLS label.  So 
>> it's really all that's needed for PWE3 purposes.
>>
> 

Isn't that simply stating the obvious?

---

From: "Andrew G. Malis" <[email-masked]>
Date: Tue, 02 Dec 2003 13:29:27 -0500

I agree fully with Mark's two messages.  The text should stand as is.

Cheers,
Andy

----------

At 12/2/2003 06:04 PM +0100, W. Mark Townsley wrote:

>>>>maintaining PSN tunnels with GRE or IP. It describes encapsulation procedures.
>>>
>>>
>>>

---

From: Yakov Rekhter <[email-masked]>
Date: Tue, 02 Dec 2003 13:29:18 -0800

Stewart,

> The new text is prescriptive about MPLS-OVER-IP-GRE being THE method.

Let's look at the proposed text again:

The new text is prescriptive about MPLS-OVER-IP-GRE being THE method,
*but only* when the tunnel is GRE or IP.

On the other hand, the new text is *not* prescriptive about MPLS-OVER-IP-GRE
being the only way to carry MPLS packets through non-MPLS IP networks.

> Do we have WG concensus for that?

In view of the above could you please be more specific about what
do you mean by "that".

Yakov.